<template>
    <div class=" box-table--body wow fadeInUp">
        <div class="box-body--left">
            <p class="text-id">{{ formattedDate }}</p>
        </div>
        <div class="box-body--right">
            <p class="text-idBlueBold">{{ operation.user.login }}</p>
            <p class="text-idBlueBold">{{ amount_text }}</p>
            <p class="text-id">{{ operation.wallet ? operation.wallet.payment_system.name : '' }}</p>
            <p class="text-id">{{ operation.payment_system ? operation.payment_system.name : '' }}</p>
            <p class="text-id" :class="statusClass">{{ status }}</p>
            <p class="text-idIcon">
                <svg class="delete" @click="reject" v-if="canReject">
                    <use xlink:href="/img/sprite.svg#cancel-button"></use>
                </svg>
                <svg class="green" @click="success" v-if="canSuccess">
                    <use xlink:href="/img/sprite.svg#check-mark-2"></use>
                </svg>
            </p>
        </div>
    </div>
</template>

<script>
    import Currencies from './../currencies';
    import {mapGetters} from "vuex";

	export default {
		name: "Operation",
        props: ['operation'],
        data(){
			return {
            }
        },
        computed: {
            ...mapGetters([
                'axios'
            ]),
			formattedDate(){
				return this.$date(this.operation.created_at).format('DD.MM.YYYY HH:mm');
            },
            amount_text(){
				return  `${Currencies.formatWithDefault(this.operation.amount, this.operation.currency)}`;
            },
            statusClass(){
				return {
				    'orange' : this.operation.status === 'in_progress' || this.operation.status === 'created',
				    'red' : this.operation.status === 'rejected' || this.operation.status === 'canceled',
				    'green' : this.operation.status === 'success',
                };
            },
            status(){
			    return this.$t('operations.statuses.' + this.operation.status);
            },
            canReject(){
                return _.includes(['created', 'success', 'in_progress'], this.operation.status);
            },
            canSuccess(){
                return this.operation.status !== 'success';
            },
        },
        methods: {
            success(){
                this.axios
                    .post(`operations/${this.operation.id}/success`)
                    .then(data => data.data)
                    .then(data => {
                        if(data.status === 'success'){
                            this.$swal(this.$t('ui.success'));
                            this.$emit('reload', true);
                        }else{
                            this.$swal(this.$t('ui.error'), data.message, 'error')
                        }
                    });
            },
            reject(){
                this.axios
                    .post(`operations/${this.operation.id}/reject`)
                    .then(data => data.data)
                    .then(data => {
                        if(data.status === 'success'){
                            this.$swal(this.$t('ui.success'));
                            this.$emit('reload', true);
                        }else{
                            this.$swal(this.$t('ui.error'), data.message, 'error')
                        }
                    });
            },
        }
	}
</script>

<style scoped>

</style>
